% Gene expression at high cell density model.
% Updated 17/06/2020 Alejandro Vignoni
% Modified in 2021 by Sungwook Lee
function [dxdt] = R10632_I10032_model_SingleCell(t,x,p)
%x1 = mRNA_100
dxdt(1,1) =p.CN*p.k1_100-p.d1*x(1);
%x2 = LuxI
dxdt(2,1)=p.k2_32*x(1)-p.d2*x(2);
%x3 = LuxR
dxdt(3,1)= p.k2_32*x(7)-p.d2*x(3) -MolesToMolecules(p.kRA * MoleculesToMoles(x(3))* MoleculesToMoles(x(4)))+p.k_RA*x(5);
%x4 = HSL
dxdt(4,1) = p.VmaxL*x(2)-MolesToMolecules(p.kRA * MoleculesToMoles(x(3))* MoleculesToMoles(x(4)))+p.k_RA*x(5)-MolesToMolecules(p.kdiff*(MoleculesToMoles(x(4))));
%x5 = HSL/LuxR
dxdt(5,1) = MolesToMolecules(p.kRA * MoleculesToMoles(x(3))* MoleculesToMoles(x(4)))-(p.k_RA+p.d2)*x(5)-2*MolesToMolecules(p.kRA2 * MoleculesToMoles(x(5))^2)+2*p.k_RA2*x(6);
%x6 = HSL/AHL dimer
dxdt(6,1) = MolesToMolecules(p.kRA2 * MoleculesToMoles(x(5))^2)-p.k_RA2*x(6);
%x7 = mRNA_106
dxdt(7,1) =p.CN*p.k1_106- p.d1*x(7);
end

function [y] = MoleculesToMoles(x)
y= x/(6.02*10^23* 1.3*10^(-15));
end

function [y] = MolesToMolecules(x)
y= x*(6.02*10^23* 1.3*10^(-15));
end